<template>
    <div class="list wow fadeInRightBig" v-if="hasPages">
        <a href="#" class="text-list" v-if="!onFirstPage" @click.prevent="setPage(currentPage - 1)">
            <svg transform="rotate(180)">
                <use xlink:href="/img/sprite.svg#long-arrow-pointing-to-the-right"/>
            </svg>
        </a>

        <a class="text-list"
           :href="getPageUrl(page)"
           :class="{'text-list-active': page === currentPage}"
           :aria-disabled="page === '...' ? 'true' : ''"
           :aria-current="page === currentPage ? 'page' : ''"
           v-for="page in pageRange"
           @click.prevent="setPage(page)"
        >
            {{ page }}
        </a>

        <a href="#" class="text-list" v-if="hasMorePages"  @click.prevent="setPage(currentPage + 1)">
            <svg>
                <use xlink:href="/img/sprite.svg#long-arrow-pointing-to-the-right"/>
            </svg>
        </a>
    </div>
</template>

<script>
    export default {
        name: "Paginator",
        props: {
            itemsCount: {
                required: true,
                type: Number,
                default: 0
            },
            currentPage: {
                required: true,
                type: Number,
                default: 1
            },
            perPage: {
                required: true,
                type: Number,
                default: 25
            }
        },
        computed: {
            lastPage(){
                return Math.ceil(this.itemsCount / this.perPage)
            },
            hasPages(){
                return this.currentPage !== 1 || this.itemsCount > this.perPage;
            },
            onFirstPage(){
                return this.currentPage <= 1;
            },
            hasMorePages(){
                return this.currentPage < this.lastPage;
            },
            pageRange () {
                var delta = 3;
                var range = [];
                var pages = [];
                var l;

                for (var i = 1; i <= this.lastPage; i++) {
                    if (i === 1 || i === this.lastPage || (i >= this.currentPage - delta && i < this.currentPage + delta + 1)) {
                        range.push(i);
                    }
                }

                range.forEach(function (i) {
                    if (l) {
                        if (i - l === 2) {
                            pages.push(l + 1);
                        } else if (i - l !== 1) {
                            pages.push('...');
                        }
                    }
                    pages.push(i);
                    l = i;
                });

                return pages;
            }
        },
        methods: {
            setPage(page){
                if(Number.isInteger(page)){
                    this.$emit('page-changed', page);
                }
            },
            getPageUrl(page){
                return '#page-' + page;
            }
        },
    }
</script>

<style lang="scss" scoped>
    .list{
        display: flex;
        justify-content: flex-start;
        align-items: center;
        margin-top: 20px;
        .text-list{
            color: #9d9d9d;
            font-family: 'Geometria Bold';
            margin-right: 12px;
            font-size: 14px;
            font-weight: 700;
            line-height: 25.87px;
            text-decoration: none;
            transition-duration: 500ms;
            transition-property: color, fill;
            &:hover{
                color: #2b5ede;
                svg {
                    fill: #2b5ede;
                }
            }
            svg {
                /* Style for "long-arrow" */
                width: 23px;
                height: 11px;
                fill: #cdcdcd;
                margin-left: calc(27px - 12px);
                transition-duration: 500ms;
                transition-property: color, fill;
            }
        }
        .text-list-active {
            color: #2a5ddd;
        }
    }
</style>
